
#include "F28x_Project.h"

void SpiConfig(void);
void SpiFifoConfig(void);

interrupt void SPIATransmitISR(void);
interrupt void SPIAReceiveISR(void);

#define SPIFIFOLENGTH 16
#define MAX_LENGTH 0x1000

Uint16 i,rdata[SPIFIFOLENGTH];

Uint16 SD_DATA[MAX_LENGTH];

#pragma DATA_SECTION(SD_DATA,"SDdataFile");

#pragma DATA_SECTION(AdcaRegs,"AdcaRegsFile");


int main(void) {
	
	InitSysCtrl();

	InitSpiaGpio();

	GPIO_SetupPinOptions(19,GPIO_OUTPUT,GPIO_ASYNC);

	EALLOW;
	GpioDataRegs.GPACLEAR.bit.GPIO19 = 1;
	EDIS;

	DINT;

	InitPieCtrl();

	IER = 0x0000;
	IFR = 0x0000;

	InitPieVectTable();

	EALLOW;
	PieVectTable.SPIA_TX_INT = &SPIATransmitISR;
	PieVectTable.SPIA_RX_INT = &SPIAReceiveISR;
	EDIS;

	PieCtrlRegs.PIEIER6.bit.INTx1 = 1;
	PieCtrlRegs.PIEIER6.bit.INTx2 = 1;

	IER |= 0x0020;

	EINT;

	for(i=0;i<SPIFIFOLENGTH;i++)
	{
		rdata[i] = 0x7625;
	}


	SpiaSlaveConfig();

	for(;;);

}





interrupt void SPIATransmitISR(void)
{
	ESTOP0;
}

interrupt void SPIAReceiveISR(void)
{
	static counter=0;

	EALLOW;
	for(i=0;i<=SPIFIFOLENGTH-1;i++)
	{
	   SD_DATA[counter+i]= (SpiaRegs.SPIRXBUF&1);     // Read data

	}

	counter = counter + SPIFIFOLENGTH;

	if(counter>=0x1000)
	{
		ESTOP0;
	}

    SpiaRegs.SPIFFRX.bit.RXFFOVFCLR=1;  // Clear Overflow flag
    SpiaRegs.SPIFFRX.bit.RXFFINTCLR=1;  // Clear Interrupt flag
	PieCtrlRegs.PIEACK.all|=0x20;       // Issue PIE ack
	EDIS;
}
